package com.cm.sa.admin.module.business.commission.service;

package ..deTemp.1744774021435;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.cm.sa.admin.module.business.commission.domain.entity.BalanceChangeEntity;
import com.cm.sa.admin.module.business.commission.domain.entity.CommissionRecordEntity;
import com.cm.sa.admin.module.business.commission.domain.entity.CommissionRecordTraceEntity;
import com.cm.sa.admin.module.business.commission.domain.entity.CommissionTotalEntity;
import com.cm.sa.admin.module.business.commission.domain.form.OrderQualityForm;
import com.cm.sa.admin.module.business.commission.domain.form.PaymentTypesCommissionForm;
import com.cm.sa.admin.module.business.commission.domain.form.UpdateAgentCommissionForm;
import com.cm.sa.admin.module.business.commission.domain.form.UpdateAgentProductPaymentTypesCommissionForm;
import com.cm.sa.admin.module.business.commission.domain.vo.CommissionRecordOrderVO;
import com.cm.sa.admin.module.business.commission.service.CommissionRecordService;
import com.cm.sa.admin.module.business.order.dao.OrderQualityLogDao;
import com.cm.sa.admin.module.business.order.domain.entity.OrderEntity;
import com.cm.sa.admin.module.business.order.domain.entity.OrderQualityLogEntity;
import com.cm.sa.admin.module.business.order.service.CardOrderService;
import com.cm.sa.admin.module.business.order.service.OrderService;
import com.cm.sa.admin.module.business.product.domain.entity.AgentCardProductPaymentTypeEntity;
import com.cm.sa.admin.module.business.product.domain.entity.CardProductEntity;
import com.cm.sa.admin.module.business.product.domain.entity.CardProductPaymentTypeEntity;
import com.cm.sa.admin.module.business.product.domain.form.AgentCardProductForm;
import com.cm.sa.admin.module.business.product.service.AgentCardProductPaymentTypeService;
import com.cm.sa.admin.module.business.product.service.AgentCardProductService;
import com.cm.sa.admin.module.business.product.service.CardProductPaymentTypeService;
import com.cm.sa.admin.module.business.product.service.CardProductService;
import com.cm.sa.admin.module.business.shop.domain.entity.AgentShopEntity;
import com.cm.sa.admin.module.business.shop.domain.vo.SelfAgentShopVO;
import com.cm.sa.admin.module.business.shop.service.AgentShopService;
import com.cm.sa.admin.module.business.shop.service.AgentWithdrawAccountService;
import com.cm.sa.admin.module.system.employee.dao.EmployeeDao;
import com.cm.sa.admin.module.system.employee.domain.form.EmployeeQueryForm;
import com.cm.sa.admin.module.system.employee.domain.vo.EmployeeVO;
import com.cm.sa.admin.module.system.mq.RocketMqService;
import com.cm.sa.base.common.domain.RequestUser;
import com.cm.sa.base.common.domain.ResponseDTO;
import com.cm.sa.base.common.util.CommonUtil;
import com.cm.sa.base.common.util.SmartBeanUtil;
import com.cm.sa.base.common.util.SmartBigDecimalUtil;
import com.cm.sa.base.common.util.SmartRequestUtil;
import com.cm.sa.base.module.support.config.ConfigKeyEnum;
import com.cm.sa.base.module.support.config.ConfigService;
import com.cm.sa.base.module.support.externalinterface.dto.PhoneNumberOnLineResultDTO;
import com.cm.sa.base.module.support.externalinterface.util.PhoneNumberOnLineUtil;
import com.cm.sa.base.module.support.redis.RedisService;
import com.cm.sa.base.module.support.redis.RedissonService;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.redisson.api.RLock;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class CommissionService {
  private static final Logger log = LoggerFactory.getLogger(com.cm.sa.admin.module.business.commission.service.CommissionService.class);
  
  @Resource
  private AgentWithdrawAccountService agentWithdrawAccountService;
  
  @Resource
  private AgentCardProductService agentCardProductService;
  
  @Resource
  private EmployeeDao employeeDao;
  
  @Resource
  private CardProductService cardProductService;
  
  @Resource
  private RedisService redisService;
  
  @Resource
  private CardOrderService cardOrderService;
  
  @Resource
  private OrderService orderService;
  
  @Resource
  private CommissionRecordService commissionRecordService;
  
  @Resource
  private RocketMqService rocketMqService;
  
  @Resource
  private ConfigService configService;
  
  @Resource
  private RedissonService redissonService;
  
  @Resource
  private AgentCardProductPaymentTypeService agentCardProductPaymentTypeService;
  
  @Resource
  private AgentShopService agentShopService;
  
  @Resource
  private CardProductPaymentTypeService cardProductPaymentTypeService;
  
  @Resource
  private OrderQualityLogDao orderQualityLogDao;
  
  public AgentCardProductPaymentTypeEntity setProductCommissionOld(AgentCardProductPaymentTypeEntity agentCardProduct, AgentCardProductPaymentTypeEntity parentProduct, String userType, Long productId, SelfAgentShopVO shopVO, BigDecimal defaultPercent) {
    if (ObjectUtil.isNotEmpty(parentProduct)) {
      agentCardProduct.setParentAmount(parentProduct.getMyAmount());
      if (!"710103".equals(userType)) {
        if (ObjectUtil.isEmpty(agentCardProduct.getParentDeductDenominator())) {
          agentCardProduct.setParentDeductDenominator(new BigDecimal(100));
          agentCardProduct.setParentDeductNumerator(shopVO.getDefaultDeductPercent());
        } 
        BigDecimal deductAmount = SmartBigDecimalUtil.multiply(parentProduct.getMyAmount(), defaultPercent, 2);
        agentCardProduct.setParentDeductAmount(deductAmount);
        agentCardProduct.setMyAmount(SmartBigDecimalUtil.subtract(parentProduct.getMyAmount(), deductAmount, 2));
      } 
    } 
    return agentCardProduct;
  }
  
  public AgentCardProductPaymentTypeEntity setProductCommission(AgentCardProductPaymentTypeEntity agentCardProduct, AgentCardProductPaymentTypeEntity parentProduct, String userType, Long productId, SelfAgentShopVO shopVO, BigDecimal defaultPercent) {
    if (ObjectUtil.isNotEmpty(parentProduct))
      if (!"710103".equals(userType))
        if (ObjectUtil.isEmpty(agentCardProduct.getParentDeductDenominator())) {
          agentCardProduct.setParentDeductDenominator(new BigDecimal(100));
          agentCardProduct.setParentDeductNumerator(shopVO.getDefaultDeductPercent());
        }   
    return agentCardProduct;
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> setAgentCommission(UpdateAgentCommissionForm updateForm) {
    List<AgentCardProductPaymentTypeEntity> updateList = new ArrayList<>();
    List<AgentCardProductPaymentTypeEntity> productList = this.agentCardProductPaymentTypeService.getAllByUserId(updateForm.getBelongUserId());
    SelfAgentShopVO shopVO = this.agentShopService.getMyShopInfo(updateForm.getBelongUserId());
    if (ObjectUtil.isNotEmpty(updateForm.getReturnFlag()) && updateForm.getReturnFlag().booleanValue()) {
      if (ObjectUtil.isNotEmpty(updateForm.getCardProductIds()) && updateForm.getCardProductIds().size() > 0)
        productList = this.agentCardProductPaymentTypeService.getProductByCardProductIdsPaymentEmployeeId(updateForm.getCardProductIds(), updateForm.getBelongUserId()); 
      for (AgentCardProductPaymentTypeEntity product : productList) {
        product.setParentDeductNumerator(shopVO.getParentDeductPercent());
        BigDecimal denominator = new BigDecimal(100);
        product.setParentDeductDenominator(denominator);
        product.setCustomDeductFlag(Boolean.valueOf(false));
        updateList.add(product);
      } 
    } else {
      if (ObjectUtil.isEmpty(updateForm.getCustomDeductFlag()))
        updateForm.setCustomDeductFlag(Boolean.valueOf(false)); 
      AgentShopEntity shop = (AgentShopEntity)SmartBeanUtil.copy(shopVO, AgentShopEntity.class);
      String maxDeduct = this.configService.getConfigValue(ConfigKeyEnum.MAX_DEDUCT_PERCENT);
      if (SmartBigDecimalUtil.isGreaterThan(updateForm.getDefaultDeductPercent(), new BigDecimal(maxDeduct)))
        return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
      if (ObjectUtil.isNotEmpty(updateForm.getDefaultDeductPercent())) {
        shop.setParentDeductPercent(updateForm.getDefaultDeductPercent());
        this.agentShopService.update(shop);
      } 
      for (AgentCardProductPaymentTypeEntity product : productList) {
        if (updateForm.getCustomDeductFlag().booleanValue() || !product.getCustomDeductFlag().booleanValue()) {
          product.setParentDeductNumerator(updateForm.getDefaultDeductPercent());
          BigDecimal denominator = new BigDecimal(100);
          product.setParentDeductDenominator(denominator);
          product.setCustomDeductFlag(Boolean.valueOf(false));
          updateList.add(product);
        } 
      } 
    } 
    this.agentCardProductPaymentTypeService.batchInsertOrUpdate(null, null, updateList);
    if (ObjectUtil.isNotNull(updateForm.getDefaultDeductPercent()))
      this.agentShopService.updateParentDeductByUserId(updateForm.getDefaultDeductPercent(), updateForm.getBelongUserId()); 
    return ResponseDTO.ok();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> setAgentProductCommission(UpdateAgentCommissionForm updateForm) {
    if (ObjectUtil.isEmpty(updateForm.getDefaultDeductPercent()) && ObjectUtil.isEmpty(updateForm.getMyAmount()))
      return ObjectUtil.isEmpty(updateForm.getMoneyOrPercent()) ? 
        ResponseDTO.userErrorParam("佣金比例为空") : 
        ResponseDTO.userErrorParam("代理佣金为空"); 
    AgentCardProductPaymentTypeEntity paymentTypeEntity = this.agentCardProductPaymentTypeService.getProductByCardProductIdPaymentEmployeeId(updateForm.getCardProductIds().get(0), updateForm.getPaymentType(), updateForm.getBelongUserId());
    BigDecimal oldDenominator = SmartBigDecimalUtil.multiply(SmartBigDecimalUtil.divide(paymentTypeEntity.getParentDeductNumerator(), paymentTypeEntity.getParentDeductDenominator(), 8), new BigDecimal(100), 2);
    String maxDeduct = this.configService.getConfigValue(ConfigKeyEnum.MAX_DEDUCT_PERCENT);
    if (ObjectUtil.isNotEmpty(paymentTypeEntity)) {
      log.info("原产品抽佣分子：：" + paymentTypeEntity.getParentDeductNumerator());
      log.info("原产品抽佣分母：：" + paymentTypeEntity.getParentDeductDenominator());
      log.info("原产品抽佣比例：：" + oldDenominator);
      if (ObjectUtil.isNotEmpty(updateForm.getDefaultDeductPercent())) {
        log.info("现产品抽佣比例：：" + updateForm.getDefaultDeductPercent());
        if (SmartBigDecimalUtil.equals(oldDenominator, updateForm.getDefaultDeductPercent()))
          return ResponseDTO.userErrorParam("佣金未改变，不修改"); 
      } 
    } 
    if (ObjectUtil.isNotEmpty(updateForm.getMoneyOrPercent()) && updateForm.getMoneyOrPercent().booleanValue()) {
      if (ObjectUtil.isEmpty(updateForm.getCardProductId()) && ObjectUtil.isEmpty(updateForm.getCardProductIds()))
        return ResponseDTO.userErrorParam("产品id为空"); 
      if (ObjectUtil.isEmpty(updateForm.getMyAmount()))
        return ResponseDTO.userErrorParam("代理佣金为空"); 
      if (SmartBigDecimalUtil.isGreaterThan(BigDecimal.ZERO, updateForm.getMyAmount()))
        return ResponseDTO.userErrorParam("代理佣金不能为负"); 
      if (ObjectUtil.isEmpty(updateForm.getCardProductId()))
        updateForm.setCardProductId(updateForm.getCardProductIds().get(0)); 
      EmployeeVO employeeVO = this.employeeDao.getEmployeeById(updateForm.getBelongUserId());
      List<Long> userIdList = (List<Long>)(new ArrayList(Arrays.asList((Object[])employeeVO.getUserChain().split(",")))).stream().map(id -> Long.valueOf(Long.parseLong(id))).collect(Collectors.toList());
      userIdList.add(updateForm.getBelongUserId());
      List<AgentCardProductPaymentTypeEntity> productList = this.agentCardProductPaymentTypeService.getProductByCardProductIdPaymentEmployeeIds(updateForm.getCardProductId(), updateForm.getPaymentType(), userIdList);
      BigDecimal deductAmount = ((AgentCardProductPaymentTypeEntity)productList.get(0)).getMyAmount();
      RequestUser user = SmartRequestUtil.getRequestUser();
      if (productList.size() == 2) {
        BigDecimal fenzi = SmartBigDecimalUtil.subtract(deductAmount, updateForm.getMyAmount(), 2);
        BigDecimal newDenominator = SmartBigDecimalUtil.multiply(SmartBigDecimalUtil.divide(fenzi, deductAmount, 8), new BigDecimal(100), 2);
        log.info("现产品佣金：：" + updateForm.getMyAmount());
        log.info("上级佣金：：" + deductAmount);
        log.info("现产品抽佣比例：：" + newDenominator);
        if (SmartBigDecimalUtil.equals(oldDenominator, newDenominator))
          return ResponseDTO.userErrorParam("佣金未改变，不修改"); 
        BigDecimal precent = SmartBigDecimalUtil.multiply(SmartBigDecimalUtil.divide(fenzi, deductAmount, 8), new BigDecimal(100), 2);
        if (SmartBigDecimalUtil.isGreaterThan(precent, new BigDecimal(maxDeduct)))
          return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
        AgentCardProductPaymentTypeEntity product = productList.get(1);
        product.setParentDeductNumerator(fenzi);
        product.setParentDeductDenominator(deductAmount);
        product.setCustomDeductFlag(Boolean.valueOf(true));
        product.setUpdateTime(LocalDateTime.now());
        product.setUpdateUserId(user.getUserId());
        product.setUpdateUserName(user.getUserName());
        this.agentCardProductPaymentTypeService.update(product);
      } else {
        for (int i = 1; i < productList.size(); i++) {
          if (i == productList.size() - 1) {
            if (SmartBigDecimalUtil.isGreaterThan(updateForm.getMyAmount(), deductAmount))
              return ResponseDTO.userErrorParam("下级代理佣金不能超过我的佣金：" + deductAmount + "元。"); 
            BigDecimal fenzi = SmartBigDecimalUtil.subtract(deductAmount, updateForm.getMyAmount(), 4);
            BigDecimal precent = SmartBigDecimalUtil.multiply(SmartBigDecimalUtil.divide(fenzi, deductAmount, 8), new BigDecimal(100), 2);
            if (SmartBigDecimalUtil.isGreaterThan(precent, new BigDecimal(maxDeduct)))
              return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
            BigDecimal newDenominator = SmartBigDecimalUtil.multiply(SmartBigDecimalUtil.divide(fenzi, deductAmount, 8), new BigDecimal(100), 2);
            log.info("现产品佣金：：" + updateForm.getMyAmount());
            log.info("上级佣金：：" + deductAmount);
            log.info("现产品抽佣比例：：" + newDenominator);
            if (SmartBigDecimalUtil.equals(oldDenominator, newDenominator))
              return ResponseDTO.userErrorParam("佣金未改变，不修改"); 
            AgentCardProductPaymentTypeEntity product = productList.get(i);
            product.setParentDeductNumerator(fenzi);
            product.setParentDeductDenominator(deductAmount);
            product.setCustomDeductFlag(Boolean.valueOf(true));
            product.setUpdateTime(LocalDateTime.now());
            product.setUpdateUserId(user.getUserId());
            product.setUpdateUserName(user.getUserName());
            this.agentCardProductPaymentTypeService.update(product);
          } 
          BigDecimal deduct = SmartBigDecimalUtil.divide(SmartBigDecimalUtil.multiply(deductAmount, ((AgentCardProductPaymentTypeEntity)productList.get(i)).getParentDeductNumerator(), 8), ((AgentCardProductPaymentTypeEntity)productList
              .get(i)).getParentDeductDenominator(), 4);
          deductAmount = SmartBigDecimalUtil.subtract(deductAmount, deduct, 4);
        } 
      } 
    } else {
      if (SmartBigDecimalUtil.isGreaterThan(updateForm.getDefaultDeductPercent(), new BigDecimal(maxDeduct)))
        return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
      if (ObjectUtil.isNotEmpty(updateForm.getPaymentType()) && updateForm.getCardProductIds().size() == 1) {
        this.agentCardProductPaymentTypeService.updateDeductByUserAndProductType(updateForm.getDefaultDeductPercent(), updateForm.getBelongUserId(), updateForm.getCardProductIds().get(0), updateForm.getPaymentType());
      } else {
        this.agentCardProductPaymentTypeService.updateDeductByUserAndProduct(updateForm.getDefaultDeductPercent(), updateForm.getBelongUserId(), updateForm.getCardProductIds());
      } 
    } 
    return ResponseDTO.ok();
  }
  
  public AgentCardProductPaymentTypeEntity getAgentCardProductPaymentTypeToSet(Long belongUserId, Long cardProductId, String paymentType) {
    EmployeeVO employeeVO = this.employeeDao.getEmployeeById(belongUserId);
    if ("710103".equals(employeeVO.getUserType())) {
      CardProductPaymentTypeEntity productEntity = this.cardProductPaymentTypeService.getByProductIdPaymentType(cardProductId, paymentType).get(0);
      AgentCardProductPaymentTypeEntity entity = this.agentCardProductPaymentTypeService.getProductByCardProductIdPaymentEmployeeId(cardProductId, paymentType, belongUserId);
      entity.setMyAmount(productEntity.getSaleAmount());
      entity.setParentDeductAmount(productEntity.getChannelAmount());
      entity.setParentAmount(productEntity.getChannelAmount());
      entity.setParentDeductNumerator(productEntity.getChannelAmount());
      entity.setParentDeductDenominator(productEntity.getAgentAmount());
      return entity;
    } 
    List<Long> userIdList = new ArrayList<>();
    if (ObjectUtil.isNotNull(employeeVO.getUserChain()))
      userIdList = (List<Long>)(new ArrayList(Arrays.asList((Object[])employeeVO.getUserChain().split(",")))).stream().map(Long::parseLong).collect(Collectors.toList()); 
    userIdList.add(belongUserId);
    List<AgentCardProductPaymentTypeEntity> productList = this.agentCardProductPaymentTypeService.getProductByCardProductIdPaymentEmployeeIds(cardProductId, paymentType, userIdList);
    BigDecimal deductAmount = ((AgentCardProductPaymentTypeEntity)productList.get(0)).getMyAmount();
    AgentCardProductPaymentTypeEntity backProduct = productList.get(0);
    if (productList.size() == 2) {
      AgentCardProductPaymentTypeEntity product = productList.get(1);
      product.setParentAmount(deductAmount);
      BigDecimal parentDeductAmount = SmartBigDecimalUtil.divide(SmartBigDecimalUtil.multiply(deductAmount, product.getParentDeductNumerator(), 20), product.getParentDeductDenominator(), 2);
      product.setParentDeductAmount(parentDeductAmount);
      product.setMyAmount(SmartBigDecimalUtil.subtract(deductAmount, parentDeductAmount, 2));
      backProduct = product;
    } else {
      for (int i = 1; i < productList.size(); i++) {
        if (i == productList.size() - 1) {
          AgentCardProductPaymentTypeEntity product = productList.get(i);
          product.setParentAmount(deductAmount);
          BigDecimal parentDeductAmount = SmartBigDecimalUtil.divide(SmartBigDecimalUtil.multiply(deductAmount, product.getParentDeductNumerator(), 20), product.getParentDeductDenominator(), 2);
          product.setParentDeductAmount(parentDeductAmount);
          product.setMyAmount(SmartBigDecimalUtil.subtract(deductAmount, parentDeductAmount, 2));
          backProduct = product;
        } 
        BigDecimal deduct = SmartBigDecimalUtil.divide(SmartBigDecimalUtil.multiply(deductAmount, ((AgentCardProductPaymentTypeEntity)productList.get(i)).getParentDeductNumerator(), 20), ((AgentCardProductPaymentTypeEntity)productList
            .get(i)).getParentDeductDenominator(), 2);
        deductAmount = SmartBigDecimalUtil.subtract(deductAmount, deduct, 2);
      } 
    } 
    return backProduct;
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> setAgentProductPaymentTypesCommission(UpdateAgentProductPaymentTypesCommissionForm form) {
    String maxDeduct = this.configService.getConfigValue(ConfigKeyEnum.MAX_DEDUCT_PERCENT);
    for (PaymentTypesCommissionForm updateForm : form.getPaymentTypeList()) {
      if (ObjectUtil.isEmpty(updateForm.getDefaultDeductPercent()) && ObjectUtil.isEmpty(updateForm.getMyAmount()))
        return ObjectUtil.isEmpty(updateForm.getMoneyOrPercent()) ? 
          ResponseDTO.userErrorParam("佣金比例为空") : 
          ResponseDTO.userErrorParam("代理佣金为空"); 
      if (ObjectUtil.isNotEmpty(updateForm.getMoneyOrPercent()) && updateForm.getMoneyOrPercent().booleanValue()) {
        if (SmartBigDecimalUtil.isGreaterThan(BigDecimal.ZERO, updateForm.getMyAmount()))
          return ResponseDTO.userErrorParam("代理佣金不能为负"); 
        EmployeeVO employeeVO = this.employeeDao.getEmployeeById(form.getBelongUserId());
        List<Long> userIdList = (List<Long>)(new ArrayList(Arrays.asList((Object[])employeeVO.getUserChain().split(",")))).stream().map(id -> Long.valueOf(Long.parseLong(id))).collect(Collectors.toList());
        userIdList.add(form.getBelongUserId());
        List<AgentCardProductPaymentTypeEntity> productList = this.agentCardProductPaymentTypeService.getProductByCardProductIdPaymentEmployeeIds(form.getCardProductId(), updateForm.getPaymentType(), userIdList);
        BigDecimal deductAmount = ((AgentCardProductPaymentTypeEntity)productList.get(0)).getMyAmount();
        RequestUser user = SmartRequestUtil.getRequestUser();
        if (productList.size() == 2) {
          AgentCardProductPaymentTypeEntity product = productList.get(1);
          product.setParentDeductNumerator(SmartBigDecimalUtil.subtract(deductAmount, updateForm.getMyAmount(), 2));
          product.setParentDeductDenominator(deductAmount);
          product.setCustomDeductFlag(Boolean.valueOf(true));
          product.setUpdateTime(LocalDateTime.now());
          product.setUpdateUserId(user.getUserId());
          product.setUpdateUserName(user.getUserName());
          this.agentCardProductPaymentTypeService.update(product);
          continue;
        } 
        for (int i = 1; i < productList.size(); i++) {
          if (i == productList.size() - 1) {
            if (SmartBigDecimalUtil.isGreaterThan(updateForm.getMyAmount(), deductAmount))
              return ResponseDTO.userErrorParam("下级代理佣金不能超过我的佣金：" + deductAmount + "元。"); 
            BigDecimal fenzi = SmartBigDecimalUtil.subtract(deductAmount, updateForm.getMyAmount(), 4);
            BigDecimal precent = SmartBigDecimalUtil.divide(SmartBigDecimalUtil.multiply(fenzi, new BigDecimal(100), 2), deductAmount, 2);
            if (SmartBigDecimalUtil.isGreaterThan(precent, new BigDecimal(maxDeduct)))
              return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
            if (SmartBigDecimalUtil.isGreaterThan(updateForm.getDefaultDeductPercent(), new BigDecimal(maxDeduct)))
              return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
            AgentCardProductPaymentTypeEntity product = productList.get(i);
            product.setParentDeductNumerator(fenzi);
            product.setParentDeductDenominator(deductAmount);
            product.setCustomDeductFlag(Boolean.valueOf(true));
            product.setUpdateTime(LocalDateTime.now());
            product.setUpdateUserId(user.getUserId());
            product.setUpdateUserName(user.getUserName());
            this.agentCardProductPaymentTypeService.update(product);
          } 
          BigDecimal deduct = SmartBigDecimalUtil.divide(SmartBigDecimalUtil.multiply(deductAmount, ((AgentCardProductPaymentTypeEntity)productList.get(i)).getParentDeductNumerator(), 8), ((AgentCardProductPaymentTypeEntity)productList
              .get(i)).getParentDeductDenominator(), 4);
          deductAmount = SmartBigDecimalUtil.subtract(deductAmount, deduct, 4);
        } 
        continue;
      } 
      if (SmartBigDecimalUtil.isGreaterThan(updateForm.getDefaultDeductPercent(), new BigDecimal(maxDeduct)))
        return ResponseDTO.userErrorParam("抽佣比例不能大于" + maxDeduct + "%"); 
      this.agentCardProductPaymentTypeService.updateDeductByUserAndProductType(updateForm.getDefaultDeductPercent(), form.getBelongUserId(), form.getCardProductId(), updateForm.getPaymentType());
    } 
    return ResponseDTO.ok();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> setAgentProductCommissionNew(UpdateAgentCommissionForm updateForm) {
    if (ObjectUtil.isEmpty(updateForm.getDefaultDeductPercent()))
      return ResponseDTO.userErrorParam("佣金比例为空"); 
    this.agentCardProductPaymentTypeService.updateDeductByUserAndProduct(updateForm.getDefaultDeductPercent(), updateForm.getBelongUserId(), updateForm.getCardProductIds());
    this.agentShopService.updateParentDeductByUserId(updateForm.getDefaultDeductPercent(), updateForm.getBelongUserId());
    return ResponseDTO.ok();
  }
  
  @Transactional(rollbackFor = {Exception.class})
  public ResponseDTO<String> setAgentCommissionOld(UpdateAgentCommissionForm updateForm) {
    EmployeeQueryForm employeeQueryForm = new EmployeeQueryForm();
    employeeQueryForm.setEmployeeId(updateForm.getBelongUserId());
    employeeQueryForm.setUserChain(updateForm.getBelongUserId().toString());
    employeeQueryForm.setUserType("710103");
    employeeQueryForm.setAllPublicChildren(Boolean.valueOf(true));
    List<EmployeeVO> agentEmployeeVOList = this.employeeDao.queryAllAgentEmployee(employeeQueryForm);
    List<Long> employeeIdList = (List<Long>)agentEmployeeVOList.stream().map(EmployeeVO::getEmployeeId).collect(Collectors.toList());
    employeeIdList.add(updateForm.getParentId());
    if (CollectionUtil.isEmpty(updateForm.getCardProductIds()) && ObjectUtil.isNotEmpty(updateForm.getCardProductId())) {
      List<Long> productIdList = new ArrayList<>();
      productIdList.add(updateForm.getCardProductId());
      updateForm.setCardProductIds(productIdList);
    } 
    List<AgentCardProductForm> productList = this.agentCardProductService.getByEmployeeId(employeeIdList, "710103", updateForm.getCardProductIds(), updateForm.getPaymentType());
    Map<Integer, List<AgentCardProductForm>> productMap = (Map<Integer, List<AgentCardProductForm>>)productList.stream().collect(Collectors.toMap(AgentCardProductForm::getAgentLevel, each -> Collections.singletonList(each), (value1, value2) -> {
            List<AgentCardProductForm> levelList = new ArrayList<>(value1);
            levelList.addAll(value2);
            return levelList;
          }));
    List<AgentCardProductPaymentTypeEntity> updateList = new ArrayList<>();
    TreeMap<Integer, List<AgentCardProductForm>> treeMap = new TreeMap<>(productMap);
    Map<Long, Map<Long, AgentCardProductForm>> parentProductMap = new HashMap<>();
    for (Integer k : treeMap.keySet()) {
      if (k == treeMap.firstKey()) {
        parentProductMap = (Map<Long, Map<Long, AgentCardProductForm>>)((List)treeMap.get(k)).stream().collect(Collectors.toMap(AgentCardProductForm::getCardProductId, e -> {
                Map<Long, AgentCardProductForm> listToMap = new HashMap<>();
                listToMap.put(e.getBelongUserId(), e);
                return listToMap;
              }(map1, map2) -> {
                map1.putAll(map2);
                return map1;
              }));
        continue;
      } 
      for (AgentCardProductForm form : treeMap.get(k)) {
        Map<Long, AgentCardProductForm> productParentMap = parentProductMap.get(form.getCardProductId());
        if (k.intValue() == ((Integer)treeMap.firstKey()).intValue() + 1) {
          if (ObjectUtil.isEmpty(updateForm.getCustomDeductFlag()))
            updateForm.setCustomDeductFlag(Boolean.valueOf(false)); 
          if (ObjectUtil.isNotEmpty(form.getCustomDeductFlag()) && (
            !form.getCustomDeductFlag().booleanValue() || (form.getCustomDeductFlag().booleanValue() && updateForm.getCustomDeductFlag().booleanValue()))) {
            form.setParentDeductNumerator(updateForm.getDefaultDeductPercent());
            BigDecimal denominator = new BigDecimal(100);
            form.setParentDeductDenominator(denominator);
            form.setParentAmount(((AgentCardProductForm)productParentMap.get(form.getParentId())).getMyAmount());
            form.setCustomDeductFlag(Boolean.valueOf(false));
            log.info("层级：" + k + ";;用户：" + form.getBelongUserId() + ";;设置用户：" + updateForm.getBelongUserId() + ";;覆盖");
          } 
          SelfAgentShopVO shopVO = this.agentShopService.getMyShopInfo(updateForm.getBelongUserId());
          AgentShopEntity shop = (AgentShopEntity)SmartBeanUtil.copy(shopVO, AgentShopEntity.class);
          if (ObjectUtil.isNotEmpty(updateForm.getDefaultDeductPercent())) {
            shop.setParentDeductPercent(updateForm.getDefaultDeductPercent());
            this.agentShopService.update(shop);
          } 
          if (ObjectUtil.isNotEmpty(updateForm.getReturnFlag()) && 
            updateForm.getReturnFlag().booleanValue()) {
            form.setParentDeductNumerator(shopVO.getParentDeductPercent());
            BigDecimal denominator = new BigDecimal(100);
            form.setParentDeductDenominator(denominator);
            form.setCustomDeductFlag(Boolean.valueOf(false));
            form.setParentAmount(((AgentCardProductForm)productParentMap.get(form.getParentId())).getMyAmount());
            log.info("恢复专属抽佣比例：层级：" + k + ";;用户：" + form.getBelongUserId() + ";;设置用户：" + updateForm.getBelongUserId());
          } 
        } else {
          form.setParentAmount(((AgentCardProductForm)productParentMap.get(form.getParentId())).getMyAmount());
          log.info("批量设置佣金其他层级：" + k + ";;用户：" + form.getBelongUserId() + ";;设置用户：" + updateForm.getBelongUserId());
        } 
        BigDecimal defaultPercent = SmartBigDecimalUtil.divide(form.getParentDeductNumerator(), form.getParentDeductDenominator(), 4);
        BigDecimal deductAmount = SmartBigDecimalUtil.multiply(form.getParentAmount(), defaultPercent, 2);
        form.setParentDeductAmount(deductAmount);
        form.setMyAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), deductAmount, 2));
        productParentMap.put(form.getBelongUserId(), form);
        AgentCardProductPaymentTypeEntity productEntity = (AgentCardProductPaymentTypeEntity)SmartBeanUtil.copy(form, AgentCardProductPaymentTypeEntity.class);
        updateList.add(productEntity);
        parentProductMap.put(form.getCardProductId(), productParentMap);
      } 
    } 
    this.agentCardProductPaymentTypeService.batchInsertOrUpdate(null, null, updateList);
    return ResponseDTO.ok();
  }
  
  public ResponseDTO<String> setAgentProductCommissionOld(UpdateAgentCommissionForm updateForm) {
    EmployeeQueryForm employeeQueryForm = new EmployeeQueryForm();
    employeeQueryForm.setEmployeeId(updateForm.getBelongUserId());
    employeeQueryForm.setUserChain(updateForm.getBelongUserId().toString());
    employeeQueryForm.setUserType("710103");
    employeeQueryForm.setAllPublicChildren(Boolean.valueOf(true));
    List<EmployeeVO> agentEmployeeVOList = this.employeeDao.queryAllAgentEmployee(employeeQueryForm);
    List<Long> employeeIdList = (List<Long>)agentEmployeeVOList.stream().map(EmployeeVO::getEmployeeId).collect(Collectors.toList());
    if (CollectionUtil.isEmpty(updateForm.getCardProductIds())) {
      List<Long> productIdList = new ArrayList<>();
      productIdList.add(updateForm.getCardProductId());
      updateForm.setCardProductIds(productIdList);
    } 
    List<AgentCardProductForm> productList = this.agentCardProductService.getByEmployeeId(employeeIdList, "710103", updateForm.getCardProductIds(), updateForm.getPaymentType());
    Map<Integer, List<AgentCardProductForm>> productMap = (Map<Integer, List<AgentCardProductForm>>)productList.stream().collect(Collectors.toMap(AgentCardProductForm::getAgentLevel, each -> Collections.singletonList(each), (value1, value2) -> {
            List<AgentCardProductForm> levelList = new ArrayList<>(value1);
            levelList.addAll(value2);
            return levelList;
          }));
    List<AgentCardProductPaymentTypeEntity> updateList = new ArrayList<>();
    TreeMap<Integer, List<AgentCardProductForm>> treeMap = new TreeMap<>(productMap);
    Map<Long, Map<Long, AgentCardProductForm>> parentProductMap = new HashMap<>();
    for (Integer k : treeMap.keySet()) {
      if (k == treeMap.firstKey()) {
        parentProductMap = (Map<Long, Map<Long, AgentCardProductForm>>)((List)treeMap.get(k)).stream().collect(Collectors.toMap(AgentCardProductForm::getCardProductId, e -> {
                Map<Long, AgentCardProductForm> listToMap = new HashMap<>();
                if (ObjectUtil.isEmpty(updateForm.getMoneyOrPercent()) || !updateForm.getMoneyOrPercent().booleanValue()) {
                  e.setDefaultDeductPercent(updateForm.getDefaultDeductPercent());
                  e.setParentDeductNumerator(updateForm.getDefaultDeductPercent());
                  e.setParentDeductDenominator(new BigDecimal(100));
                  BigDecimal amount = SmartBigDecimalUtil.multiply(e.getParentAmount(), SmartBigDecimalUtil.divide(updateForm.getDefaultDeductPercent(), new BigDecimal(100), 4), 2);
                  e.setMyAmount(amount);
                  e.setParentDeductAmount(SmartBigDecimalUtil.subtract(e.getParentAmount(), amount, 2));
                } else {
                  e.setMyAmount(updateForm.getMyAmount());
                  e.setParentDeductDenominator(e.getParentAmount());
                  e.setParentDeductNumerator(updateForm.getMyAmount());
                  e.setParentDeductAmount(SmartBigDecimalUtil.subtract(e.getParentAmount(), updateForm.getMyAmount(), 2));
                } 
                e.setCustomDeductFlag(Boolean.valueOf(true));
                listToMap.put(e.getBelongUserId(), e);
                return listToMap;
              }(map1, map2) -> {
                map1.putAll(map2);
                return map1;
              }));
        List<AgentCardProductPaymentTypeEntity> agentProductList = (List<AgentCardProductPaymentTypeEntity>)((List)treeMap.get(k)).stream().map(form -> {
              if (ObjectUtil.isEmpty(updateForm.getMoneyOrPercent()) || !updateForm.getMoneyOrPercent().booleanValue()) {
                form.setDefaultDeductPercent(updateForm.getDefaultDeductPercent());
                form.setParentDeductNumerator(updateForm.getDefaultDeductPercent());
                form.setParentDeductDenominator(new BigDecimal(100));
                BigDecimal amount = SmartBigDecimalUtil.multiply(form.getParentAmount(), SmartBigDecimalUtil.divide(updateForm.getDefaultDeductPercent(), new BigDecimal(100), 4), 2);
                form.setParentDeductAmount(amount);
                form.setMyAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), amount, 2));
              } else {
                form.setMyAmount(updateForm.getMyAmount());
                form.setParentDeductDenominator(form.getParentAmount());
                form.setParentDeductNumerator(updateForm.getMyAmount());
                form.setParentDeductAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), updateForm.getMyAmount(), 2));
              } 
              AgentCardProductPaymentTypeEntity productEntity = (AgentCardProductPaymentTypeEntity)SmartBeanUtil.copy(form, AgentCardProductPaymentTypeEntity.class);
              productEntity.setCustomDeductFlag(Boolean.valueOf(true));
              return productEntity;
            }).collect(Collectors.toList());
        updateList.addAll(agentProductList);
        continue;
      } 
      for (AgentCardProductForm form : treeMap.get(k)) {
        Map<Long, AgentCardProductForm> productParentMap = parentProductMap.get(form.getCardProductId());
        form.setParentAmount(((AgentCardProductForm)productParentMap.get(form.getParentId())).getMyAmount());
        BigDecimal denominator = new BigDecimal(100);
        form.setParentDeductDenominator(denominator);
        BigDecimal numberator = ObjectUtil.isNotNull(form.getParentDeductPercent()) ? form.getParentDeductPercent() : ((AgentCardProductForm)productParentMap.get(form.getParentId())).getDefaultDeductPercent();
        form.setParentDeductNumerator(numberator);
        BigDecimal defaultPercent = SmartBigDecimalUtil.divide(numberator, denominator, 4);
        BigDecimal deductAmount = SmartBigDecimalUtil.multiply(form.getParentAmount(), defaultPercent, 2);
        form.setParentDeductAmount(deductAmount);
        form.setMyAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), deductAmount, 2));
        productParentMap.put(form.getBelongUserId(), form);
        AgentCardProductPaymentTypeEntity productEntity = (AgentCardProductPaymentTypeEntity)SmartBeanUtil.copy(form, AgentCardProductPaymentTypeEntity.class);
        updateList.add(productEntity);
        parentProductMap.put(form.getCardProductId(), productParentMap);
      } 
    } 
    this.agentCardProductPaymentTypeService.batchInsertOrUpdate(null, null, updateList);
    return ResponseDTO.ok();
  }
  
  public ResponseDTO<String> setAgentProductPaymentTypesCommissionOld(UpdateAgentProductPaymentTypesCommissionForm updateForm) {
    EmployeeQueryForm employeeQueryForm = new EmployeeQueryForm();
    employeeQueryForm.setEmployeeId(updateForm.getBelongUserId());
    employeeQueryForm.setUserChain(updateForm.getBelongUserId().toString());
    employeeQueryForm.setUserType("710103");
    employeeQueryForm.setAllPublicChildren(Boolean.valueOf(true));
    List<EmployeeVO> agentEmployeeVOList = this.employeeDao.queryAllAgentEmployee(employeeQueryForm);
    List<Long> employeeIdList = (List<Long>)agentEmployeeVOList.stream().map(EmployeeVO::getEmployeeId).collect(Collectors.toList());
    List<Long> productIdList = new ArrayList<>();
    productIdList.add(updateForm.getCardProductId());
    List<AgentCardProductForm> productList = this.agentCardProductService.getByEmployeeId(employeeIdList, "710103", productIdList, null);
    Map<Integer, List<AgentCardProductForm>> productMap = (Map<Integer, List<AgentCardProductForm>>)productList.stream().collect(Collectors.toMap(AgentCardProductForm::getAgentLevel, each -> Collections.singletonList(each), (value1, value2) -> {
            List<AgentCardProductForm> levelList = new ArrayList<>(value1);
            levelList.addAll(value2);
            return levelList;
          }));
    List<AgentCardProductPaymentTypeEntity> updateList = new ArrayList<>();
    TreeMap<Integer, List<AgentCardProductForm>> treeMap = new TreeMap<>(productMap);
    Map<Long, Map<Long, AgentCardProductForm>> parentProductMap = new HashMap<>();
    for (Integer k : treeMap.keySet()) {
      if (k == treeMap.firstKey()) {
        parentProductMap = (Map<Long, Map<Long, AgentCardProductForm>>)((List)treeMap.get(k)).stream().collect(Collectors.toMap(AgentCardProductForm::getCardProductId, e -> {
                Map<Long, AgentCardProductForm> listToMap = new HashMap<>();
                for (PaymentTypesCommissionForm pForm : updateForm.getPaymentTypeList()) {
                  if (pForm.getPaymentType().equals(e.getPaymentType())) {
                    if (ObjectUtil.isEmpty(pForm.getMoneyOrPercent()) || !pForm.getMoneyOrPercent().booleanValue()) {
                      e.setDefaultDeductPercent(pForm.getDefaultDeductPercent());
                      e.setParentDeductNumerator(pForm.getDefaultDeductPercent());
                      e.setParentDeductDenominator(new BigDecimal(100));
                      BigDecimal amount = SmartBigDecimalUtil.multiply(e.getParentAmount(), SmartBigDecimalUtil.divide(pForm.getDefaultDeductPercent(), new BigDecimal(100), 4), 2);
                      e.setMyAmount(amount);
                      e.setParentDeductAmount(SmartBigDecimalUtil.subtract(e.getParentAmount(), amount, 2));
                    } else {
                      e.setMyAmount(pForm.getMyAmount());
                      e.setParentDeductDenominator(e.getParentAmount());
                      e.setParentDeductNumerator(pForm.getMyAmount());
                      e.setParentDeductAmount(SmartBigDecimalUtil.subtract(e.getParentAmount(), pForm.getMyAmount(), 2));
                    } 
                    listToMap.put(e.getBelongUserId(), e);
                  } 
                } 
                return listToMap;
              }(map1, map2) -> {
                map1.putAll(map2);
                return map1;
              }));
        List<AgentCardProductPaymentTypeEntity> agentProductList = (List<AgentCardProductPaymentTypeEntity>)((List)treeMap.get(k)).stream().map(form -> {
              for (PaymentTypesCommissionForm pForm : updateForm.getPaymentTypeList()) {
                if (pForm.getPaymentType().equals(form.getPaymentType())) {
                  if (ObjectUtil.isEmpty(pForm.getMoneyOrPercent()) || !pForm.getMoneyOrPercent().booleanValue()) {
                    form.setDefaultDeductPercent(pForm.getDefaultDeductPercent());
                    form.setParentDeductNumerator(pForm.getDefaultDeductPercent());
                    form.setParentDeductDenominator(new BigDecimal(100));
                    BigDecimal amount = SmartBigDecimalUtil.multiply(form.getParentAmount(), SmartBigDecimalUtil.divide(pForm.getDefaultDeductPercent(), new BigDecimal(100), 4), 2);
                    form.setParentDeductAmount(amount);
                    form.setMyAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), amount, 2));
                    continue;
                  } 
                  form.setMyAmount(pForm.getMyAmount());
                  form.setParentDeductDenominator(form.getParentAmount());
                  form.setParentDeductNumerator(pForm.getMyAmount());
                  form.setParentDeductAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), pForm.getMyAmount(), 2));
                } 
              } 
              AgentCardProductPaymentTypeEntity productEntity = (AgentCardProductPaymentTypeEntity)SmartBeanUtil.copy(form, AgentCardProductPaymentTypeEntity.class);
              productEntity.setCustomDeductFlag(Boolean.valueOf(true));
              return productEntity;
            }).collect(Collectors.toList());
        updateList.addAll(agentProductList);
        continue;
      } 
      for (AgentCardProductForm form : treeMap.get(k)) {
        Map<Long, AgentCardProductForm> productParentMap = parentProductMap.get(form.getCardProductId());
        form.setParentAmount(((AgentCardProductForm)productParentMap.get(form.getParentId())).getMyAmount());
        BigDecimal denominator = new BigDecimal(100);
        form.setParentDeductDenominator(denominator);
        BigDecimal numberator = ObjectUtil.isNotNull(form.getParentDeductPercent()) ? form.getParentDeductPercent() : ((AgentCardProductForm)productParentMap.get(form.getParentId())).getDefaultDeductPercent();
        form.setParentDeductNumerator(numberator);
        BigDecimal defaultPercent = SmartBigDecimalUtil.divide(numberator, denominator, 4);
        BigDecimal deductAmount = SmartBigDecimalUtil.multiply(form.getParentAmount(), defaultPercent, 2);
        form.setParentDeductAmount(deductAmount);
        form.setMyAmount(SmartBigDecimalUtil.subtract(form.getParentAmount(), deductAmount, 2));
        productParentMap.put(form.getBelongUserId(), form);
        AgentCardProductPaymentTypeEntity productEntity = (AgentCardProductPaymentTypeEntity)SmartBeanUtil.copy(form, AgentCardProductPaymentTypeEntity.class);
        updateList.add(productEntity);
        parentProductMap.put(form.getCardProductId(), productParentMap);
      } 
    } 
    this.agentCardProductPaymentTypeService.batchInsertOrUpdate(null, null, updateList);
    return ResponseDTO.ok();
  }
  
  public ResponseDTO<String> getAgentProductCommission(UpdateAgentCommissionForm updateForm) {
    return ResponseDTO.ok();
  }
  
  public void orderPaymentCommission(List<Long> orderIdList, Map<Long, List<CommissionRecordOrderVO>> orderRecordMap) {
    Map<Long, Map<?, ?>> rechargeAmountMap = this.cardOrderService.getRechargeAmount(orderIdList);
    List<OrderEntity> orderEntityList = new ArrayList<>();
    List<CommissionRecordEntity> commissionRecordEntityList = new ArrayList<>();
    List<BalanceChangeEntity> balanceChangeEntityList = new ArrayList<>();
    Map<Long, CommissionTotalEntity> totalMap = new HashMap<>();
    List<Long> mqOrderIdList = new ArrayList<>();
    for (Long orderId : orderIdList) {
      List<CommissionRecordOrderVO> recordList = new ArrayList<>();
      if (CollectionUtil.isEmpty(orderRecordMap)) {
        recordList = this.commissionRecordService.getWaitPaymentOrder(orderId);
      } else {
        recordList = orderRecordMap.get(orderId);
      } 
      String phone = ((CommissionRecordOrderVO)recordList.get(0)).getBusinessNo();
      OrderEntity orderEntity = new OrderEntity();
      orderEntity.setOrderId(orderId);
      if (ObjectUtil.isNotNull(phone)) {
        Map<?, ?> amountMap = rechargeAmountMap.get(orderId);
        BigDecimal recvhargeAmount = ObjectUtil.isNotEmpty(amountMap.get("rechargeAmount")) ? new BigDecimal(amountMap.get("rechargeAmount").toString()) : BigDecimal.ZERO;
        CardProductEntity cardProductEntity = this.cardProductService.getProductById(((CommissionRecordOrderVO)recordList.get(0)).getCardProductId());
        BigDecimal paymentAmount = ObjectUtil.isNotEmpty(cardProductEntity.getPaymentRule()) ? cardProductEntity.getPaymentRule() : BigDecimal.ZERO;
        log.info(orderId + "订单充值金额：" + recvhargeAmount + ";;充值达标金额：" + paymentAmount);
        if (SmartBigDecimalUtil.isGreaterOrEqual(recvhargeAmount, paymentAmount)) {
          log.info(orderId + "订单开始月结");
          orderEntity.setCardProductId(((CommissionRecordOrderVO)recordList.get(0)).getCardProductId());
          orderEntity.setCommissionSnapshot(((CommissionRecordOrderVO)recordList.get(0)).getCommissionSnapshot());
          ResponseDTO<PhoneNumberOnLineResultDTO> result = PhoneNumberOnLineUtil.checkSyncMode(phone);
          orderEntity.setQualityNameType("710200");
          orderEntity.setQualityTime(LocalDateTime.now());
          if (result.getOk().booleanValue()) {
            PhoneNumberOnLineResultDTO dto = (PhoneNumberOnLineResultDTO)result.getData();
            if (1 == dto.getStatus().intValue()) {
              orderEntity.setQualityResultType(Boolean.valueOf(true));
              orderEntity.setQualityResultDesc(dto.getStatusDesc());
              orderEntity.setPaymentStatus("610201");
              orderEntity.setPaymentTime(LocalDateTime.now());
              orderEntity.setQualityStatus("610701");
              if ("710601".equals(orderEntity.getPaymentType())) {
                orderEntity.setOrderStatus("610107");
              } else {
                orderEntity.setOrderStatus("610104");
              } 
              paymentCommission(recordList, totalMap, balanceChangeEntityList, commissionRecordEntityList);
            } else if (6 == dto.getStatus().intValue() || 7 == dto.getStatus().intValue() || 9 == dto.getStatus().intValue() || 10 == dto.getStatus().intValue()) {
              orderEntity.setQualityResultDesc("待人工质检,接口质检信息：" + dto.getStatusDesc());
              orderEntity.setQualityType(Boolean.valueOf(false));
              orderEntity.setQualityStatus("610700");
            } else {
              int days = Integer.parseInt(this.configService.getConfigValue(ConfigKeyEnum.RECHECK_DAYS));
              LocalDateTime qualityTime = LocalDateTime.now().plusDays(days);
              orderEntity.setRecheckDate(qualityTime);
              List<CommissionRecordEntity> updateCommissionRecordList = (List<CommissionRecordEntity>)recordList.stream().map(vo -> {
                    CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(vo, CommissionRecordEntity.class);
                    commissionRecordEntity.setQualityResultType(Boolean.valueOf(false));
                    return commissionRecordEntity;
                  }).collect(Collectors.toList());
              commissionRecordEntityList.addAll(updateCommissionRecordList);
              orderEntity.setQualityResultType(Boolean.valueOf(false));
              orderEntity.setQualityHandleStatus("610400");
              orderEntity.setQualityResultDesc(dto.getStatusDesc());
              orderEntity.setRecheckStatus("610400");
              orderEntity.setQualityStatus("610701");
              int counts = 5;
              try {
                counts = Integer.parseInt(this.configService.getConfigValue(ConfigKeyEnum.RECHECK_TIMES));
              } catch (Exception e) {
                log.error(e.getMessage(), e);
              } 
              orderEntity.setRecheckTimes(Integer.valueOf(counts));
            } 
          } else {
            orderEntity.setQualityResultDesc("待人工质检,接口质检信息：" + result.getMsg());
            orderEntity.setQualityType(Boolean.valueOf(false));
            orderEntity.setQualityStatus("610700");
          } 
        } 
      } else {
        orderEntity.setQualityResultDesc("无业务号码，待人工质检");
        orderEntity.setQualityType(Boolean.valueOf(false));
        orderEntity.setQualityStatus("610700");
        orderEntity.setQualityNameType("710200");
      } 
      orderEntityList.add(orderEntity);
    } 
    List<CommissionTotalEntity> commissionTotalEntityList = new ArrayList<>(totalMap.values());
    this.orderService.paymentMonth(orderEntityList, commissionRecordEntityList, commissionTotalEntityList, balanceChangeEntityList, null);
    if (CollectionUtil.isNotEmpty(mqOrderIdList)) {
      long time = 21600000L;
      this.rocketMqService.messageSendDeliver("quality-phone", mqOrderIdList, time);
    } 
  }
  
  public void paymentCommission(List<CommissionRecordOrderVO> recordList, Map<Long, CommissionTotalEntity> totalMap, List<BalanceChangeEntity> balanceChangeEntityList, List<CommissionRecordEntity> commissionRecordEntityList) {
    for (CommissionRecordOrderVO recordOrderVO : recordList) {
      CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(recordOrderVO, CommissionRecordEntity.class);
      CommissionTotalEntity totalEntity = totalMap.get(recordOrderVO.getCommissionTotalId());
      if (ObjectUtil.isEmpty(totalEntity))
        totalEntity = (CommissionTotalEntity)SmartBeanUtil.copy(recordOrderVO, CommissionTotalEntity.class); 
      totalEntity.setUpdateTime(LocalDateTime.now());
      BigDecimal balanceAmount = ObjectUtil.isNotNull(totalEntity.getBalanceAmount()) ? totalEntity.getBalanceAmount() : BigDecimal.ZERO;
      totalEntity.setBalanceAmount(SmartBigDecimalUtil.add(balanceAmount, commissionRecordEntity.getAmount(), 2));
      BigDecimal waitAmount = ObjectUtil.isNotNull(totalEntity.getWaitPaymentAmount()) ? totalEntity.getWaitPaymentAmount() : commissionRecordEntity.getAmount();
      totalEntity.setWaitPaymentAmount(SmartBigDecimalUtil.subtract(waitAmount, commissionRecordEntity.getAmount(), 2));
      totalMap.put(recordOrderVO.getCommissionTotalId(), totalEntity);
      BalanceChangeEntity balanceChangeEntity = new BalanceChangeEntity();
      String financeNo = CommonUtil.generate();
      balanceChangeEntity.setFinanceNo(financeNo);
      balanceChangeEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
      balanceChangeEntity.setBelongUserId(recordOrderVO.getBelongUserId());
      balanceChangeEntity.setAmount(commissionRecordEntity.getAmount());
      balanceChangeEntity.setAmountType(Boolean.valueOf(true));
      balanceChangeEntity.setBalanceAmount(totalEntity.getBalanceAmount());
      balanceChangeEntity.setChangeType("710703");
      balanceChangeEntity.setCreateTime(LocalDateTime.now());
      Long balanceId = Long.valueOf(IdWorker.getId(balanceChangeEntity));
      balanceChangeEntity.setBalanceChangeId(balanceId);
      balanceChangeEntityList.add(balanceChangeEntity);
      commissionRecordEntity.setQualityResultType(Boolean.valueOf(true));
      commissionRecordEntity.setPaymentStatus("610201");
      commissionRecordEntity.setPaymentTime(LocalDateTime.now());
      commissionRecordEntity.setUpdateTime(LocalDateTime.now());
      commissionRecordEntity.setBalanceChangeId(balanceId);
      commissionRecordEntityList.add(commissionRecordEntity);
    } 
  }
  
  public void commissionTrace(List<Long> orderIdList, Map<Long, List<CommissionRecordOrderVO>> orderRecordMap) {
    List<Long> mqOrderIdList = new ArrayList<>();
    List<OrderEntity> orderList = new ArrayList<>();
    List<CommissionRecordEntity> commissionRecordList = new ArrayList<>();
    List<BalanceChangeEntity> balanceChangeList = new ArrayList<>();
    List<CommissionRecordTraceEntity> traceList = new ArrayList<>();
    Map<Long, CommissionTotalEntity> totalMap = new HashMap<>();
    for (Long orderId : orderIdList) {
      List<CommissionRecordOrderVO> recordList = new ArrayList<>();
      if (CollectionUtil.isEmpty(orderRecordMap)) {
        recordList = this.commissionRecordService.getWaitPaymentOrder(orderId);
      } else {
        recordList = orderRecordMap.get(orderId);
      } 
      String phone = ((CommissionRecordOrderVO)recordList.get(0)).getBusinessNo();
      OrderEntity orderEntity = new OrderEntity();
      orderEntity.setOrderId(orderId);
      if (orderEntity.getQualityType().booleanValue() && ObjectUtil.isNotNull(orderEntity.getBusinessNo())) {
        ResponseDTO<PhoneNumberOnLineResultDTO> result = PhoneNumberOnLineUtil.checkSyncMode(phone);
        orderEntity.setQualityTime(LocalDateTime.now());
        if (result.getOk().booleanValue()) {
          PhoneNumberOnLineResultDTO dto = (PhoneNumberOnLineResultDTO)result.getData();
          if (1 == dto.getStatus().intValue()) {
            orderEntity.setQualityResultType(Boolean.valueOf(true));
            orderEntity.setOrderStatus("610107");
            orderEntity.setQualityResultDesc(dto.getStatusDesc());
            orderEntity.setQualityType(Boolean.valueOf(true));
            orderEntity.setQualityStatus("610701");
            orderEntity.setQualityNameType("710201");
            List<CommissionRecordEntity> commissionRecordEntityList = (List<CommissionRecordEntity>)recordList.stream().map(vo -> {
                  CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(vo, CommissionRecordEntity.class);
                  commissionRecordEntity.setQualityResultType(Boolean.valueOf(true));
                  return commissionRecordEntity;
                }).collect(Collectors.toList());
            commissionRecordList.addAll(commissionRecordEntityList);
          } else if (6 == dto.getStatus().intValue() || 7 == dto.getStatus().intValue() || 9 == dto.getStatus().intValue() || 10 == dto.getStatus().intValue()) {
            orderEntity.setQualityResultDesc("待人工质检,接口质检信息：" + result.getMsg());
            orderEntity.setQualityType(Boolean.valueOf(false));
            orderEntity.setQualityStatus("610700");
            orderEntity.setQualityNameType("710201");
          } else {
            int days = Integer.parseInt(this.configService.getConfigValue(ConfigKeyEnum.RECHECK_DAYS));
            LocalDateTime qualityTime = LocalDateTime.now().plusDays(days);
            orderEntity.setRecheckDate(qualityTime);
            int counts = 5;
            try {
              counts = Integer.parseInt(this.configService.getConfigValue(ConfigKeyEnum.RECHECK_TIMES));
            } catch (Exception e) {
              log.error(e.getMessage(), e);
            } 
            orderEntity.setRecheckTimes(Integer.valueOf(counts));
            orderEntity.setQualityResultType(Boolean.valueOf(false));
            orderEntity.setQualityType(Boolean.valueOf(true));
            orderEntity.setQualityResultDesc(dto.getStatusDesc());
            orderEntity.setQualityStatus("610701");
            orderEntity.setQualityHandleStatus("610400");
            orderEntity.setPaymentStatus("610202");
            orderEntity.setOrderStatus("610106");
            orderEntity.setRecheckStatus("610400");
            for (CommissionRecordOrderVO recordOrderVO : recordList) {
              CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(recordOrderVO, CommissionRecordEntity.class);
              commissionRecordEntity.setQualityResultType(Boolean.valueOf(false));
              commissionRecordEntity.setPaymentStatus("610202");
              commissionRecordList.add(commissionRecordEntity);
              CommissionTotalEntity totalEntity = totalMap.get(recordOrderVO.getCommissionTotalId());
              if (ObjectUtil.isEmpty(totalEntity))
                totalEntity = (CommissionTotalEntity)SmartBeanUtil.copy(recordOrderVO, CommissionTotalEntity.class); 
              totalEntity.setUpdateTime(LocalDateTime.now());
              BigDecimal balanceAmount = ObjectUtil.isNotNull(totalEntity.getBalanceAmount()) ? totalEntity.getBalanceAmount() : BigDecimal.ZERO;
              totalEntity.setBalanceAmount(SmartBigDecimalUtil.subtract(balanceAmount, recordOrderVO.getAmount(), 2));
              BigDecimal traceAmount = ObjectUtil.isNotNull(totalEntity.getTraceAmount()) ? totalEntity.getTraceAmount() : BigDecimal.ZERO;
              totalEntity.setTraceAmount(SmartBigDecimalUtil.add(traceAmount, recordOrderVO.getAmount(), 2));
              totalMap.put(recordOrderVO.getCommissionTotalId(), totalEntity);
              BalanceChangeEntity balanceChangeEntity = new BalanceChangeEntity();
              String financeNo = CommonUtil.generate();
              balanceChangeEntity.setFinanceNo(financeNo);
              balanceChangeEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
              balanceChangeEntity.setBelongUserId(recordOrderVO.getBelongUserId());
              balanceChangeEntity.setAmount(commissionRecordEntity.getAmount());
              balanceChangeEntity.setAmountType(Boolean.valueOf(false));
              balanceChangeEntity.setBalanceAmount(totalEntity.getBalanceAmount());
              balanceChangeEntity.setChangeType("710702");
              balanceChangeEntity.setCreateTime(LocalDateTime.now());
              Long balanceId = Long.valueOf(IdWorker.getId(balanceChangeEntity));
              balanceChangeEntity.setBalanceChangeId(balanceId);
              balanceChangeList.add(balanceChangeEntity);
              CommissionRecordTraceEntity traceEntity = new CommissionRecordTraceEntity();
              traceEntity.setOrderId(orderId);
              traceEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
              traceEntity.setBelongUserId(recordOrderVO.getBelongUserId());
              traceEntity.setAmount(recordOrderVO.getAmount());
              traceEntity.setOrderPaymentStatus("610202");
              traceEntity.setQualityResultType(Boolean.valueOf(false));
              traceEntity.setQualityResultDesc(dto.getStatusDesc());
              traceEntity.setBalanceChangeId(balanceId);
              String fn = CommonUtil.generate();
              traceEntity.setFinanceNo(fn);
              traceList.add(traceEntity);
            } 
          } 
        } else {
          orderEntity.setQualityResultDesc("待人工质检,接口质检信息：" + result.getMsg());
          orderEntity.setQualityType(Boolean.valueOf(false));
          orderEntity.setQualityStatus("610700");
          orderEntity.setQualityNameType("710201");
        } 
      } else {
        orderEntity.setQualityResultDesc("待人工质检追溯");
        orderEntity.setQualityType(Boolean.valueOf(false));
        orderEntity.setQualityStatus("610700");
        orderEntity.setQualityNameType("710201");
      } 
      orderList.add(orderEntity);
    } 
    List<CommissionTotalEntity> commissionTotalEntityList = new ArrayList<>(totalMap.values());
    this.orderService.paymentMonth(orderList, commissionRecordList, commissionTotalEntityList, balanceChangeList, traceList);
  }
  
  public ResponseDTO<String> quality(Long orderId, Boolean kefuFlag) {
    if (ObjectUtil.isEmpty(kefuFlag))
      kefuFlag = Boolean.valueOf(false); 
    OrderEntity orderEntity = this.orderService.getByOrderId(orderId);
    if (ObjectUtil.isNull(orderEntity))
      return ResponseDTO.userErrorParam("订单不存在"); 
    if (!orderEntity.getQualityType().booleanValue())
      return ResponseDTO.userErrorParam("人工质检订单不能接口复核"); 
    if ("610401".equals(orderEntity.getRecheckStatus()) || "610404"
      .equals(orderEntity.getRecheckStatus()) || 
      ObjectUtil.isNull(orderEntity.getRecheckStatus()))
      return ResponseDTO.userErrorParam("此订单状态不能复核"); 
    if (!kefuFlag.booleanValue()) {
      if (orderEntity.getRecheckTimes().intValue() < 1)
        return ResponseDTO.userErrorParam("订单已超过复核次数，不能复核"); 
      if ("610403".equals(orderEntity.getRecheckStatus()))
        return ResponseDTO.userErrorParam("复核已逾期"); 
    } 
    String phone = orderEntity.getBusinessNo();
    ResponseDTO<PhoneNumberOnLineResultDTO> result = PhoneNumberOnLineUtil.checkSyncMode(phone);
    if ("710200".equals(orderEntity.getQualityNameType())) {
      orderEntity.setQualityNameType("710202");
    } else {
      orderEntity.setQualityNameType("710203");
    } 
    orderEntity.setQualityTime(LocalDateTime.now());
    if (result.getOk().booleanValue()) {
      PhoneNumberOnLineResultDTO dto = (PhoneNumberOnLineResultDTO)result.getData();
      orderEntity.setUpdateUserId(SmartRequestUtil.getRequestUserId());
      orderEntity.setUpdateUserName(SmartRequestUtil.getRequestUser().getUserName());
      orderEntity.setUpdateTime(LocalDateTime.now());
      orderEntity.setQualityResultDesc(dto.getStatusDesc());
      if (1 == dto.getStatus().intValue()) {
        if (!kefuFlag.booleanValue())
          orderEntity.setRecheckTimes(Integer.valueOf(orderEntity.getRecheckTimes().intValue() - 1)); 
        orderEntity.setOrderStatus("610107");
        orderEntity.setPaymentStatus("610201");
        orderEntity.setRecheckStatus("610401");
        orderEntity.setQualityHandleStatus("610401");
        orderEntity.setQualityStatus("610701");
        orderEntity.setQualityResultType(Boolean.valueOf(true));
        Map<Long, CommissionTotalEntity> totalMap = new HashMap<>();
        List<CommissionRecordEntity> commissionRecordEntityList = new ArrayList<>();
        List<BalanceChangeEntity> balanceChangeEntityList = new ArrayList<>();
        List<CommissionRecordTraceEntity> traceList = new ArrayList<>();
        RLock lock = this.redissonService.tryLock("commissionTotal", 600000L, 600000L);
        try {
          List<CommissionRecordOrderVO> recordOrderList = this.commissionRecordService.getWaitPaymentOrder(orderId);
          if ("610200".equals(orderEntity.getPaymentStatus())) {
            orderEntity.setPaymentTime(LocalDateTime.now());
            if ("710600".equals(orderEntity.getPaymentType()))
              orderEntity.setOrderStatus("610104"); 
            paymentCommission(recordOrderList, totalMap, balanceChangeEntityList, commissionRecordEntityList);
          } else if ("610202".equals(orderEntity.getPaymentStatus())) {
            for (CommissionRecordOrderVO recordOrderVO : recordOrderList) {
              CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(recordOrderVO, CommissionRecordEntity.class);
              commissionRecordEntity.setPaymentStatus("610201");
              commissionRecordEntity.setUpdateUserId(SmartRequestUtil.getRequestUserId());
              commissionRecordEntity.setUpdateUserName(SmartRequestUtil.getRequestUser().getUserName());
              commissionRecordEntity.setUpdateTime(LocalDateTime.now());
              commissionRecordEntityList.add(commissionRecordEntity);
              CommissionTotalEntity totalEntity = totalMap.get(recordOrderVO.getCommissionTotalId());
              if (ObjectUtil.isEmpty(totalEntity))
                totalEntity = (CommissionTotalEntity)SmartBeanUtil.copy(recordOrderVO, CommissionTotalEntity.class); 
              totalEntity.setUpdateTime(LocalDateTime.now());
              BigDecimal balanceAmount = ObjectUtil.isNotNull(totalEntity.getBalanceAmount()) ? totalEntity.getBalanceAmount() : BigDecimal.ZERO;
              totalEntity.setBalanceAmount(SmartBigDecimalUtil.add(balanceAmount, recordOrderVO.getAmount(), 2));
              BigDecimal traceAmount = ObjectUtil.isNotNull(totalEntity.getTraceAmount()) ? totalEntity.getTraceAmount() : BigDecimal.ZERO;
              totalEntity.setTraceAmount(SmartBigDecimalUtil.subtract(traceAmount, recordOrderVO.getAmount(), 2));
              totalMap.put(recordOrderVO.getCommissionTotalId(), totalEntity);
              BalanceChangeEntity balanceChangeEntity = new BalanceChangeEntity();
              String financeNo = CommonUtil.generate();
              balanceChangeEntity.setFinanceNo(financeNo);
              balanceChangeEntity.setCommissionTotalId(totalEntity.getCommissionTotalId());
              balanceChangeEntity.setBelongUserId(totalEntity.getBelongUserId());
              balanceChangeEntity.setAmount(commissionRecordEntity.getAmount());
              balanceChangeEntity.setAmountType(Boolean.valueOf(true));
              balanceChangeEntity.setBalanceAmount(totalEntity.getBalanceAmount());
              balanceChangeEntity.setChangeType("710702");
              balanceChangeEntity.setCreateTime(LocalDateTime.now());
              Long balanceId = Long.valueOf(IdWorker.getId(balanceChangeEntity));
              balanceChangeEntity.setBalanceChangeId(balanceId);
              balanceChangeEntityList.add(balanceChangeEntity);
              CommissionRecordTraceEntity traceEntity = new CommissionRecordTraceEntity();
              traceEntity.setOrderId(orderId);
              traceEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
              traceEntity.setBelongUserId(recordOrderVO.getBelongUserId());
              traceEntity.setAmount(recordOrderVO.getAmount());
              traceEntity.setOrderPaymentStatus("610201");
              traceEntity.setQualityResultType(Boolean.valueOf(true));
              traceEntity.setQualityResultDesc(dto.getStatusDesc());
              traceEntity.setBalanceChangeId(balanceId);
              String fn = CommonUtil.generate();
              traceEntity.setFinanceNo(fn);
              traceList.add(traceEntity);
            } 
          } 
        } finally {
          if (lock.isHeldByCurrentThread())
            lock.unlock(); 
        } 
        List<CommissionTotalEntity> commissionTotalEntityList = new ArrayList<>(totalMap.values());
        List<OrderEntity> orderEntityList = new ArrayList<>();
        orderEntityList.add(orderEntity);
        this.orderService.paymentMonth(orderEntityList, commissionRecordEntityList, commissionTotalEntityList, balanceChangeEntityList, null);
        return ResponseDTO.ok();
      } 
      if (6 == dto.getStatus().intValue() || 7 == dto.getStatus().intValue() || 9 == dto.getStatus().intValue() || 10 == dto.getStatus().intValue()) {
        orderEntity.setQualityResultDesc("待人工质检,复核接口质检信息：" + dto.getStatusDesc());
        orderEntity.setQualityType(Boolean.valueOf(false));
        orderEntity.setQualityStatus("610700");
        orderEntity.setRecheckStatus("610404");
        this.orderService.update(orderEntity);
        return ResponseDTO.userErrorParam("待人工复核，号码" + dto.getStatusDesc() + ",此订单可复核次数：" + orderEntity.getRecheckTimes() + "次。");
      } 
      if (!kefuFlag.booleanValue())
        orderEntity.setRecheckTimes(Integer.valueOf(orderEntity.getRecheckTimes().intValue() - 1)); 
      orderEntity.setRecheckStatus("610402");
      orderEntity.setQualityResultType(Boolean.valueOf(false));
      orderEntity.setQualityHandleStatus("610402");
      orderEntity.setQualityStatus("610701");
      orderEntity.setUpdateTime(LocalDateTime.now());
      if (orderEntity.getRecheckTimes().intValue() == 0) {
        if ("610200".equals(orderEntity.getPaymentStatus())) {
          orderEntity.setOrderStatus("610105");
          orderEntity.setPaymentStatus("610203");
          List<Long> orderIdList = new ArrayList<>();
          orderIdList.add(orderId);
          List<CommissionRecordEntity> recordList = this.commissionRecordService.getCommissionRecordsByOrderIds(orderIdList);
          recordList = (List<CommissionRecordEntity>)recordList.stream().map(r -> {
                r.setPaymentStatus("610203");
                r.setQualityResultType(Boolean.valueOf(false));
                return r;
              }).collect(Collectors.toList());
          this.orderService.updateOrderAndRecords(orderEntity, recordList);
        } else {
          orderEntity.setOrderStatus("610106");
          orderEntity.setPaymentStatus("610202");
          this.orderService.update(orderEntity);
        } 
      } else {
        if (!"610103".equals(orderEntity.getOrderStatus()))
          orderEntity.setOrderStatus("610106"); 
        this.orderService.update(orderEntity);
      } 
      return ResponseDTO.userErrorParam("复核失败，号码" + dto.getStatusDesc() + ",此订单可复核次数：" + orderEntity.getRecheckTimes() + "次。");
    } 
    orderEntity.setQualityResultDesc("待人工质检,复核接口质检信息：" + result.getMsg());
    orderEntity.setQualityType(Boolean.valueOf(false));
    orderEntity.setQualityStatus("610700");
    orderEntity.setRecheckStatus("610404");
    this.orderService.update(orderEntity);
    return ResponseDTO.userErrorParam(result.getMsg());
  }
  
  public ResponseDTO<String> manuQuality(OrderQualityForm qualityForm) {
    OrderEntity orderEntity = this.orderService.getByOrderId(qualityForm.getOrderId());
    if (ObjectUtil.isNull(orderEntity))
      return ResponseDTO.userErrorParam("订单不存在"); 
    if (orderEntity.getRecheckTimes().intValue() < 1 && "610402".equals(orderEntity.getRecheckStatus()))
      return ResponseDTO.userErrorParam("订单已超过复核次数，不能复核"); 
    if ("610403".equals(orderEntity.getRecheckStatus()))
      return ResponseDTO.userErrorParam("复核已逾期"); 
    orderEntity.setQualityStatus("610701");
    orderEntity.setQualityTime(LocalDateTime.now());
    orderEntity.setQualityResultType(qualityForm.getQualityStatus());
    orderEntity.setQualityResultDesc(qualityForm.getQualityResultDesc());
    OrderQualityLogEntity qualityLog = new OrderQualityLogEntity();
    qualityLog.setQualityType(Boolean.valueOf(false));
    qualityLog.setQualityNameType(orderEntity.getQualityNameType());
    qualityLog.setQualityResultDesc(orderEntity.getQualityResultDesc());
    qualityLog.setCreateUserId(SmartRequestUtil.getRequestUserId());
    qualityLog.setCreateTime(LocalDateTime.now());
    qualityLog.setQualityResultType(orderEntity.getQualityResultType());
    qualityLog.setCreateUserName(SmartRequestUtil.getRequestUser().getUserName());
    qualityLog.setOrderId(orderEntity.getOrderId());
    Map<Long, CommissionTotalEntity> totalMap = new HashMap<>();
    List<CommissionRecordEntity> commissionRecordEntityList = new ArrayList<>();
    List<BalanceChangeEntity> balanceChangeEntityList = new ArrayList<>();
    List<CommissionRecordTraceEntity> traceList = new ArrayList<>();
    if (qualityForm.getQualityStatus().booleanValue()) {
      orderEntity.setOrderStatus("610107");
      RLock rLock = this.redissonService.tryLock("commissionTotal", 600000L, 600000L);
      try {
        if ("710202".equals(orderEntity.getQualityNameType()) || "710203"
          .equals(orderEntity.getQualityNameType())) {
          orderEntity.setRecheckTimes(Integer.valueOf(orderEntity.getRecheckTimes().intValue() - 1));
          orderEntity.setRecheckStatus("610401");
          orderEntity.setQualityHandleStatus("610401");
          orderEntity.setPaymentStatus("610201");
          List<CommissionRecordOrderVO> recordOrderList = this.commissionRecordService.getWaitPaymentOrder(qualityForm.getOrderId());
          if ("610200".equals(orderEntity.getPaymentStatus())) {
            orderEntity.setPaymentTime(LocalDateTime.now());
            if ("710600".equals(orderEntity.getPaymentType()))
              orderEntity.setOrderStatus("610104"); 
            paymentCommission(recordOrderList, totalMap, balanceChangeEntityList, commissionRecordEntityList);
          } else if ("610202".equals(orderEntity.getPaymentStatus())) {
            for (CommissionRecordOrderVO recordOrderVO : recordOrderList) {
              CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(recordOrderVO, CommissionRecordEntity.class);
              commissionRecordEntity.setPaymentStatus("610201");
              commissionRecordEntity.setUpdateUserId(SmartRequestUtil.getRequestUserId());
              commissionRecordEntity.setUpdateUserName(SmartRequestUtil.getRequestUser().getUserName());
              commissionRecordEntity.setUpdateTime(LocalDateTime.now());
              commissionRecordEntityList.add(commissionRecordEntity);
              CommissionTotalEntity totalEntity = totalMap.get(recordOrderVO.getCommissionTotalId());
              if (ObjectUtil.isEmpty(totalEntity))
                totalEntity = (CommissionTotalEntity)SmartBeanUtil.copy(recordOrderVO, CommissionTotalEntity.class); 
              totalEntity.setUpdateTime(LocalDateTime.now());
              BigDecimal balanceAmount = ObjectUtil.isNotNull(totalEntity.getBalanceAmount()) ? totalEntity.getBalanceAmount() : BigDecimal.ZERO;
              totalEntity.setBalanceAmount(SmartBigDecimalUtil.add(balanceAmount, recordOrderVO.getAmount(), 2));
              BigDecimal traceAmount = ObjectUtil.isNotNull(totalEntity.getTraceAmount()) ? totalEntity.getTraceAmount() : BigDecimal.ZERO;
              totalEntity.setTraceAmount(SmartBigDecimalUtil.subtract(traceAmount, recordOrderVO.getAmount(), 2));
              totalMap.put(recordOrderVO.getCommissionTotalId(), totalEntity);
              BalanceChangeEntity balanceChangeEntity = new BalanceChangeEntity();
              String financeNo = CommonUtil.generate();
              balanceChangeEntity.setFinanceNo(financeNo);
              balanceChangeEntity.setCommissionTotalId(totalEntity.getCommissionTotalId());
              balanceChangeEntity.setBelongUserId(totalEntity.getBelongUserId());
              balanceChangeEntity.setAmount(commissionRecordEntity.getAmount());
              balanceChangeEntity.setAmountType(Boolean.valueOf(true));
              balanceChangeEntity.setBalanceAmount(totalEntity.getBalanceAmount());
              balanceChangeEntity.setChangeType("710702");
              balanceChangeEntity.setCreateTime(LocalDateTime.now());
              Long balanceId = Long.valueOf(IdWorker.getId(balanceChangeEntity));
              balanceChangeEntity.setBalanceChangeId(balanceId);
              balanceChangeEntityList.add(balanceChangeEntity);
              CommissionRecordTraceEntity traceEntity = new CommissionRecordTraceEntity();
              traceEntity.setOrderId(qualityForm.getOrderId());
              traceEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
              traceEntity.setBelongUserId(recordOrderVO.getBelongUserId());
              traceEntity.setAmount(recordOrderVO.getAmount());
              traceEntity.setOrderPaymentStatus("610201");
              traceEntity.setQualityResultType(Boolean.valueOf(true));
              traceEntity.setQualityResultDesc(qualityForm.getQualityResultDesc());
              traceEntity.setBalanceChangeId(balanceId);
              String fn = CommonUtil.generate();
              traceEntity.setFinanceNo(fn);
              traceList.add(traceEntity);
            } 
          } 
        } else if ("610200".equals(orderEntity.getPaymentStatus())) {
          List<CommissionRecordOrderVO> recordOrderList = this.commissionRecordService.getWaitPaymentOrder(qualityForm.getOrderId());
          orderEntity.setPaymentStatus("610201");
          orderEntity.setPaymentTime(LocalDateTime.now());
          orderEntity.setQualityStatus("610701");
          if ("710601".equals(orderEntity.getPaymentType())) {
            orderEntity.setOrderStatus("610107");
          } else {
            orderEntity.setOrderStatus("610104");
          } 
          paymentCommission(recordOrderList, totalMap, balanceChangeEntityList, commissionRecordEntityList);
        } else {
          orderEntity.setOrderStatus("610107");
          List<CommissionRecordOrderVO> recordList = this.commissionRecordService.getWaitPaymentOrder(orderEntity.getOrderId());
          commissionRecordEntityList = (List<CommissionRecordEntity>)recordList.stream().map(vo -> {
                CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(vo, CommissionRecordEntity.class);
                commissionRecordEntity.setQualityResultType(Boolean.valueOf(true));
                return commissionRecordEntity;
              }).collect(Collectors.toList());
        } 
      } finally {
        if (rLock.isHeldByCurrentThread())
          rLock.unlock(); 
      } 
      List<CommissionTotalEntity> list = new ArrayList<>(totalMap.values());
      List<OrderEntity> list1 = new ArrayList<>();
      list1.add(orderEntity);
      this.orderService.paymentMonth(list1, commissionRecordEntityList, list, balanceChangeEntityList, null);
      this.orderQualityLogDao.insert(qualityLog);
      return ResponseDTO.okMsg("已人工质检，手机在网，订单已结算/不追溯。");
    } 
    if ("710202".equals(orderEntity.getQualityNameType()) || "710203"
      .equals(orderEntity.getQualityNameType())) {
      orderEntity.setRecheckTimes(Integer.valueOf(orderEntity.getRecheckTimes().intValue() - 1));
      orderEntity.setRecheckStatus("610402");
      orderEntity.setQualityHandleStatus("610402");
      orderEntity.setUpdateTime(LocalDateTime.now());
      if (orderEntity.getRecheckTimes().intValue() == 0) {
        if ("610200".equals(orderEntity.getPaymentStatus())) {
          orderEntity.setOrderStatus("610105");
          orderEntity.setPaymentStatus("610203");
          List<Long> orderIdList = new ArrayList<>();
          orderIdList.add(qualityForm.getOrderId());
          List<CommissionRecordEntity> recordList = this.commissionRecordService.getCommissionRecordsByOrderIds(orderIdList);
          recordList = (List<CommissionRecordEntity>)recordList.stream().map(r -> {
                r.setPaymentStatus("610203");
                r.setQualityResultType(Boolean.valueOf(false));
                return r;
              }).collect(Collectors.toList());
          this.orderService.updateOrderAndRecords(orderEntity, recordList);
        } else {
          orderEntity.setOrderStatus("610106");
          orderEntity.setPaymentStatus("610202");
          this.orderService.update(orderEntity);
        } 
      } else {
        if (!"610103".equals(orderEntity.getOrderStatus()))
          orderEntity.setOrderStatus("610106"); 
        this.orderService.update(orderEntity);
      } 
      this.orderQualityLogDao.insert(qualityLog);
      return ResponseDTO.userErrorParam("复核失败，" + qualityForm.getQualityResultDesc() + "，此订单可复核次数：" + orderEntity.getRecheckTimes() + "次。");
    } 
    int days = Integer.parseInt(this.configService.getConfigValue(ConfigKeyEnum.RECHECK_DAYS));
    LocalDateTime qualityTime = LocalDateTime.now().plusDays(days);
    orderEntity.setRecheckDate(qualityTime);
    int counts = 5;
    try {
      counts = Integer.parseInt(this.configService.getConfigValue(ConfigKeyEnum.RECHECK_TIMES));
    } catch (Exception e) {
      log.error(e.getMessage(), e);
    } 
    orderEntity.setRecheckTimes(Integer.valueOf(counts));
    RLock lock = this.redissonService.tryLock("commissionTotal", 600000L, 600000L);
    try {
      if ("610200".equals(orderEntity.getPaymentStatus())) {
        List<CommissionRecordOrderVO> recordList = this.commissionRecordService.getWaitPaymentOrder(orderEntity.getOrderId());
        List<CommissionRecordEntity> updateCommissionRecordList = (List<CommissionRecordEntity>)recordList.stream().map(vo -> {
              CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(vo, CommissionRecordEntity.class);
              commissionRecordEntity.setQualityResultType(Boolean.valueOf(false));
              return commissionRecordEntity;
            }).collect(Collectors.toList());
        commissionRecordEntityList.addAll(updateCommissionRecordList);
        orderEntity.setQualityHandleStatus("610400");
        orderEntity.setRecheckStatus("610400");
        orderEntity.setQualityStatus("610701");
      } else {
        List<OrderEntity> orderList = new ArrayList<>();
        List<CommissionRecordEntity> commissionRecordList = new ArrayList<>();
        List<CommissionRecordOrderVO> recordList = this.commissionRecordService.getWaitPaymentOrder(qualityForm.getOrderId());
        orderEntity.setQualityType(Boolean.valueOf(false));
        orderEntity.setQualityStatus("610701");
        orderEntity.setQualityHandleStatus("610400");
        orderEntity.setPaymentStatus("610202");
        orderEntity.setOrderStatus("610106");
        orderEntity.setRecheckStatus("610400");
        for (CommissionRecordOrderVO recordOrderVO : recordList) {
          CommissionRecordEntity commissionRecordEntity = (CommissionRecordEntity)SmartBeanUtil.copy(recordOrderVO, CommissionRecordEntity.class);
          commissionRecordEntity.setQualityResultType(Boolean.valueOf(false));
          commissionRecordEntity.setPaymentStatus("610202");
          commissionRecordList.add(commissionRecordEntity);
          CommissionTotalEntity totalEntity = totalMap.get(recordOrderVO.getCommissionTotalId());
          if (ObjectUtil.isEmpty(totalEntity))
            totalEntity = (CommissionTotalEntity)SmartBeanUtil.copy(recordOrderVO, CommissionTotalEntity.class); 
          totalEntity.setUpdateTime(LocalDateTime.now());
          BigDecimal balanceAmount = ObjectUtil.isNotNull(totalEntity.getBalanceAmount()) ? totalEntity.getBalanceAmount() : BigDecimal.ZERO;
          totalEntity.setBalanceAmount(SmartBigDecimalUtil.subtract(balanceAmount, recordOrderVO.getAmount(), 2));
          BigDecimal traceAmount = ObjectUtil.isNotNull(totalEntity.getTraceAmount()) ? totalEntity.getTraceAmount() : BigDecimal.ZERO;
          totalEntity.setTraceAmount(SmartBigDecimalUtil.add(traceAmount, recordOrderVO.getAmount(), 2));
          totalMap.put(recordOrderVO.getCommissionTotalId(), totalEntity);
          BalanceChangeEntity balanceChangeEntity = new BalanceChangeEntity();
          String financeNo = CommonUtil.generate();
          balanceChangeEntity.setFinanceNo(financeNo);
          balanceChangeEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
          balanceChangeEntity.setBelongUserId(recordOrderVO.getBelongUserId());
          balanceChangeEntity.setAmount(commissionRecordEntity.getAmount());
          balanceChangeEntity.setAmountType(Boolean.valueOf(false));
          balanceChangeEntity.setBalanceAmount(totalEntity.getBalanceAmount());
          balanceChangeEntity.setChangeType("710702");
          balanceChangeEntity.setCreateTime(LocalDateTime.now());
          Long balanceId = Long.valueOf(IdWorker.getId(balanceChangeEntity));
          balanceChangeEntity.setBalanceChangeId(balanceId);
          balanceChangeEntityList.add(balanceChangeEntity);
          CommissionRecordTraceEntity traceEntity = new CommissionRecordTraceEntity();
          traceEntity.setOrderId(qualityForm.getOrderId());
          traceEntity.setCommissionTotalId(recordOrderVO.getCommissionTotalId());
          traceEntity.setBelongUserId(recordOrderVO.getBelongUserId());
          traceEntity.setAmount(recordOrderVO.getAmount());
          traceEntity.setOrderPaymentStatus("610202");
          traceEntity.setQualityResultType(Boolean.valueOf(false));
          traceEntity.setQualityResultDesc(qualityForm.getQualityResultDesc());
          traceEntity.setBalanceChangeId(balanceId);
          String fn = CommonUtil.generate();
          traceEntity.setFinanceNo(fn);
          traceList.add(traceEntity);
        } 
      } 
    } finally {
      if (lock.isHeldByCurrentThread())
        lock.unlock(); 
    } 
    List<CommissionTotalEntity> commissionTotalEntityList = new ArrayList<>(totalMap.values());
    List<OrderEntity> orderEntityList = new ArrayList<>();
    orderEntityList.add(orderEntity);
    this.orderService.paymentMonth(orderEntityList, commissionRecordEntityList, commissionTotalEntityList, balanceChangeEntityList, traceList);
    this.orderQualityLogDao.insert(qualityLog);
    return ResponseDTO.okMsg("已人工质检；订单待复核。\n质检结果：异常；" + qualityForm.getQualityResultDesc() + "。\n此订单可复核次数：" + orderEntity.getRecheckTimes() + "次。");
  }
}
